package pps.core.common.utils;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.regex.Pattern;

/**
 * Description:
 * date: 2020/11/18 16:47
 *
 * @author zhujiangwei
 */
public class BigDecimalUtil {

    public static BigDecimal parseBigDecimal(Object obj, int num) {
        if (obj == null) return BigDecimal.ZERO.setScale(num, RoundingMode.HALF_UP);
        BigDecimal org;
        if (obj instanceof BigDecimal) {
            org = (BigDecimal) obj;
        } else {
            String pattern = "([1-9]\\d*\\.?\\d*)|(0\\.\\d*[1-9])";
            if (!Pattern.matches(pattern, String.valueOf(obj))) { //非数字字符串
                org = BigDecimal.ZERO;
            } else {
                org = parseObj2BigDecimal(obj);
            }
        }
        return org.setScale(num, RoundingMode.HALF_UP);
    }

    public static BigDecimal parseObj2BigDecimal(Object obj) {
        if (obj == null) return BigDecimal.ZERO;
        String str = String.valueOf(obj).trim();
        if (str.isEmpty()) return BigDecimal.ZERO;
        BigDecimal result;
        try {
            result = new BigDecimal(str);
        } catch (Exception e) {
            result = BigDecimal.ZERO;
        }
        return result;
    }
}
